PHP_ARG_ENABLE(memsession, whether to enable memsession support, [])

if test "$PHP_MEMSESSION" != "no"; then

    dnl detect if ZTS is enabled or not
    php_inc_path=`$PHP_CONFIG --include-dir 2>/dev/null`
    CFLAGS="-I$php_inc_path $CFLAGS"
    AC_TRY_COMPILE([#include "main/php_config.h"],
    [#ifndef ZTS
#error ZTS is not defined
#endif
    ],
    ac_zts_enabled=yes , ac_zts_enabled=no)] 

    if test "$ac_zts_enabled" = "no"; then
       AC_MSG_ERROR(memsession only works for ZTS enabled php) 
    fi

    if test "$GCC" = "yes"; then
        AC_TRY_COMPILE([],
        [int target;
        __sync_fetch_and_add(&target, 1);
        ],
        ac_cv_gcc_atomic=yes , ac_cv_gcc_atomic=no)] 
        if test "$ac_cv_gcc_atomic" = "yes"; then
          AC_DEFINE(HAVE_GCC_ATOMICS,1,[whether you have gcc atomics availabe])
        fi


    fi

	AC_DEFINE(HAVE_MEMSESSION, 1, [Whether you have MemSession])
	PHPINSTDIR=`$PHP_CONFIG --prefix 2>/dev/null`
	PHP_ADD_INCLUDE($PHPINSTDIR/include/php/ext/session)

	PHP_NEW_EXTENSION(memsession, memsession.c, $ext_shared)
fi
