/*
 * Copyright (c) 2005, 2009 Sun Microsystems, Inc. All Rights Reserved.
 * Use is subject to license terms.
 */
/* 
   +----------------------------------------------------------------------+
   | This source file is subject to version 3.01 of the PHP license,      |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.php.net/license/3_01.txt                                  |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
   | Author: Basant Kukreja <basantk@php.net>                             |
   +----------------------------------------------------------------------+
 */

#ifndef MEMSESSION_H
#define MEMSESSION_H

extern zend_module_entry memsession_module_entry;
#define phpext_memsession_ptr &memsession_module_entry

#ifndef PHP_WIN32
#include <pthread.h>
#endif
#include "zend_atomic.h"
#include "zend_lock.h"

#define MEMSESSION_G(v) TSRMG(memsession_globals_id, zend_memsession_globals *, v)

ZEND_BEGIN_MODULE_GLOBALS(memsession)
	char* save_path;
ZEND_END_MODULE_GLOBALS(memsession)

typedef struct {
	zend_bool ctx;
} ps_memsession;

typedef struct {
	void* val;
	int vallen;
	time_t last_update_time;
	volatile unsigned int refcount;
} memsession_data;

PS_FUNCS(memsession);

typedef struct _memsession_globals {
	char* save_path;
} memsession_globals; 

#endif

